package ${basePackage}.frame.excel.handler;

import com.alibaba.excel.metadata.CellData;
import com.alibaba.excel.metadata.Head;
import com.alibaba.excel.write.handler.CellWriteHandler;
import com.alibaba.excel.write.metadata.holder.WriteSheetHolder;
import com.alibaba.excel.write.metadata.holder.WriteTableHolder;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.Drawing;
import org.apache.poi.ss.usermodel.Row;

import java.util.List;
import java.util.Map;

public class WCellWriteHandler implements CellWriteHandler {
    private CellStyle[] styles;

    private Map<Integer, String> errMap;

    public WCellWriteHandler(CellStyle[] styles, Map<Integer, String> errMap) {
        this.styles = styles;
        this.errMap = errMap;
    }


    @Override
    public void beforeCellCreate(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, Row row, Head head, Integer integer, Integer integer1, Boolean isHead) {

    }

    @Override
    public void afterCellCreate(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, Cell cell, Head head, Integer integer, Boolean isHead) {

    }

    @Override
    public void afterCellDataConverted(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, CellData cellData, Cell cell, Head head, Integer integer, Boolean isHead) {

    }

    @Override
    public void afterCellDispose(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, List<CellData> list, Cell cell, Head head, Integer rowIndex, Boolean isHead) {
        if (isHead) {
            // 创建批注
            Drawing<?> drawingPatriarch = writeSheetHolder.getSheet().createDrawingPatriarch();
//                for (int i = 0; i < wHeads.size(); i++) {
//                    WHead wHead = wHeads.get(i);
//                    if (wHead.getNote() != null && !"".equals(wHead.getNote())) {
//                        // 创建一个批注
//                        Comment comment = drawingPatriarch.createCellComment(new XSSFClientAnchor(0, 0, 0, 0, (short) i, 0, (short) i + 1, 2));
//                        // 输入批注信息
//                        comment.setString(new XSSFRichTextString(wHead.getNote()));
//                        // 将批注添加到标题对象中
//                        writeSheetHolder.getSheet().getRow(0).getCell(i).setCellComment(comment);
//                    }
//                }
            cell.setCellStyle(styles[0]);
        } else if (!"".equals(errMap.getOrDefault(rowIndex, ""))) {
//            cell.getCellStyle().setFillForegroundColor(IndexedColors.RED.getIndex());
//            cell.getCellStyle().setFillPattern(FillPatternType.SOLID_FOREGROUND);
            cell.setCellStyle(styles[1]);
        }
    }
}
